"use strict";

var _to5Helpers = require("6to5-runtime/helpers");

var _core = require("6to5-runtime/core-js");

exports.promisify = promisify;
exports.defer = defer;
function promisify(fn) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new _core.Promise(function (resolve, reject) {
      fn.apply(undefined, _to5Helpers.toArray(args).concat([function (err) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        if (err) {
          reject(err);
          return;
        }

        resolve.apply(undefined, _to5Helpers.toArray(args));
      }]));
    });
  };
}

function defer() {
  var ret = {};

  ret.promise = new _core.Promise(function (resolve, reject) {
    ret.resolve = resolve;
    ret.reject = reject;
  });

  return ret;
}
exports.__esModule = true;